paddle_build.sh 80.3 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
#!/usr/bin/env bash

# Copyright (c) 2018 PaddlePaddle Authors. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#=================================================
#                   Utils
#=================================================

21 22
set -ex

Z
Zeng Jinle 已提交
23 24 25 26
if [ -z ${BRANCH} ]; then
    BRANCH="develop"
fi

27 28
function print_usage() {
    echo -e "\n${RED}Usage${NONE}:
29
    ${BOLD}${SCRIPT_NAME}${NONE} [OPTION]"
Q
Qiyang Min 已提交
30

31 32 33
    echo -e "\n${RED}Options${NONE}:
    ${BLUE}build${NONE}: run build for x86 platform
    ${BLUE}test${NONE}: run all unit tests
34
    ${BLUE}single_test${NONE}: run a single unit test
35 36
    ${BLUE}bind_test${NONE}: parallel tests bind to different GPU
    ${BLUE}doc${NONE}: generate paddle documents
37
    ${BLUE}gen_doc_lib${NONE}: generate paddle documents library
38 39 40 41
    ${BLUE}html${NONE}: convert C++ source code into HTML
    ${BLUE}dockerfile${NONE}: generate paddle release dockerfile
    ${BLUE}fluid_inference_lib${NONE}: deploy fluid inference library
    ${BLUE}check_style${NONE}: run code style check
42 43
    ${BLUE}cicheck${NONE}: run CI tasks on Linux
    ${BLUE}maccheck${NONE}: run CI tasks on Mac
44 45 46 47
    "
}

function init() {
48 49 50 51 52
    RED='\033[0;31m'
    BLUE='\033[0;34m'
    BOLD='\033[1m'
    NONE='\033[0m'

53
    PADDLE_ROOT="$( cd "$( dirname "${BASH_SOURCE[0]}")/../../" && pwd )"
54
    export PADDLE_ROOT
55 56 57
    if [ -z "${SCRIPT_NAME}" ]; then
        SCRIPT_NAME=$0
    fi
Z
Zeng Jinle 已提交
58 59

    ENABLE_MAKE_CLEAN=${ENABLE_MAKE_CLEAN:-ON}
60 61 62

    # NOTE(chenweihang): For easy debugging, CI displays the C++ error stacktrace by default 
    export FLAGS_call_stack_level=2
63 64 65 66

    # set CI_SKIP_CPP_TEST if only *.py changed
    # In order to avoid using in some CI(such as daily performance), the current
    # branch must not be `${BRANCH}` which is usually develop.
67 68 69 70 71 72
    if [ ${CI_SKIP_CPP_TEST:-ON} == "OFF"  ];then
        echo "CI_SKIP_CPP_TEST=OFF"
    else
        if [ "$(git branch | grep "^\*" | awk '{print $2}')" != "${BRANCH}" ]; then
            git diff --name-only ${BRANCH} | grep -v "\.py$" || export CI_SKIP_CPP_TEST=ON
        fi
73
    fi
74 75
}

76
function cmake_base() {
R
randytli 已提交
77
    # Build script will not fail if *.deb does not exist
78
    rm *.deb 2>/dev/null || true
R
randytli 已提交
79
    # Delete previous built whl packages
80 81 82 83 84
    rm -rf python/dist 2>/dev/null || true

    # Support build for all python versions, currently
    # including cp27-cp27m and cp27-cp27mu.
    PYTHON_FLAGS=""
85
    SYSTEM=`uname -s`
J
Jiabin Yang 已提交
86
    if [ "$SYSTEM" == "Darwin" ]; then
V
velconia 已提交
87
        echo "Using python abi: $1"
J
Jiabin Yang 已提交
88
        if [[ "$1" == "cp27-cp27m" ]] || [[ "$1" == "" ]]; then
89 90 91
            if [ -d "/Library/Frameworks/Python.framework/Versions/2.7" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/2.7
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/2.7
J
Jiabin Yang 已提交
92
                export PATH=/Library/Frameworks/Python.framework/Versions/2.7/bin/:${PATH}
93 94
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/2.7/bin/python2.7
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/2.7/include/python2.7
J
Jiabin Yang 已提交
95
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/2.7/lib/libpython2.7.dylib"
96
                pip install --user -r ${PADDLE_ROOT}/python/requirements.txt
97 98 99
            else
                exit 1
            fi
V
velconia 已提交
100
        elif [ "$1" == "cp35-cp35m" ]; then
V
velconia 已提交
101
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.5" ]; then
V
velconia 已提交
102 103 104 105 106 107
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.5/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.5/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.5/include/python3.5m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.5/lib/libpython3.5m.dylib"
108
                pip3.5 install --user -r ${PADDLE_ROOT}/python/requirements.txt
V
velconia 已提交
109 110 111
            else
                exit 1
            fi
M
minqiyang 已提交
112 113 114 115 116 117 118 119
        elif [ "$1" == "cp36-cp36m" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.6" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.6/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.6/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.6/include/python3.6m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.6/lib/libpython3.6m.dylib"
120
                pip3.6 install --user -r ${PADDLE_ROOT}/python/requirements.txt
M
minqiyang 已提交
121 122 123 124 125 126 127 128 129 130 131
            else
                exit 1
            fi
        elif [ "$1" == "cp37-cp37m" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.7" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.7/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.7/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.7/include/python3.7m/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.7/lib/libpython3.7m.dylib"
132
                pip3.7 install --user -r ${PADDLE_ROOT}/python/requirements.txt
M
minqiyang 已提交
133 134 135
            else
                exit 1
            fi
G
guofei 已提交
136 137 138 139 140 141 142 143 144 145 146 147
        elif [ "$1" == "cp38-cp38" ]; then
            if [ -d "/Library/Frameworks/Python.framework/Versions/3.8" ]; then
                export LD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.8/lib/
                export DYLD_LIBRARY_PATH=/Library/Frameworks/Python.framework/Versions/3.8/lib/
                export PATH=/Library/Frameworks/Python.framework/Versions/3.8/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.8/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/Library/Frameworks/Python.framework/Versions/3.8/include/python3.8/
            -DPYTHON_LIBRARY:FILEPATH=/Library/Frameworks/Python.framework/Versions/3.8/lib/libpython3.8.dylib"
                pip3.8 install --user -r ${PADDLE_ROOT}/python/requirements.txt
            else
                exit 1
            fi
148
        fi
M
minqiyang 已提交
149
    else
150
        if [ "$1" != "" ]; then
M
minqiyang 已提交
151
            echo "using python abi: $1"
152
            if [ "$1" == "cp27-cp27m" ]; then
T
tianshuo78520a 已提交
153
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs2/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs4/lib:}
154 155 156
                export PATH=/opt/python/cp27-cp27m/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27m/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27m/include/python2.7
T
tianshuo78520a 已提交
157
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs2/lib/libpython2.7.so"
158
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
159
            elif [ "$1" == "cp27-cp27mu" ]; then
T
tianshuo78520a 已提交
160
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs4/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs2/lib:}
161 162 163
                export PATH=/opt/python/cp27-cp27mu/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27mu/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27mu/include/python2.7
T
tianshuo78520a 已提交
164
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs4/lib/libpython2.7.so"
165 166 167 168 169 170 171 172 173 174 175 176 177 178
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
            elif [ "$1" == "cp27-cp27m-gcc82" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs2/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs4/lib:}
                export PATH=/opt/python/cp27-cp27m/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27m/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27m/include/python2.7
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs2/lib/libpython2.7.so"
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
            elif [ "$1" == "cp27-cp27mu-gcc82" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-2.7.15-ucs4/lib:${LD_LIBRARY_PATH#/opt/_internal/cpython-2.7.15-ucs2/lib:}
                export PATH=/opt/python/cp27-cp27mu/bin/:${PATH}
                PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/python/cp27-cp27mu/bin/python
            -DPYTHON_INCLUDE_DIR:PATH=/opt/python/cp27-cp27mu/include/python2.7
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-2.7.15-ucs4/lib/libpython2.7.so"
179
                pip install -r ${PADDLE_ROOT}/python/requirements.txt
180 181 182 183
            elif [ "$1" == "cp35-cp35m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.5.1/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.5.1/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.5.1/bin/python3
M
minqiyang 已提交
184 185
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.5.1/include/python3.5m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.5.1/lib/libpython3.so"
186
                pip3.5 install -r ${PADDLE_ROOT}/python/requirements.txt
187 188 189 190 191 192
            elif [ "$1" == "cp36-cp36m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.6.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.6.0/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.6.0/bin/python3
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.6.0/include/python3.6m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.6.0/lib/libpython3.so"
193
                pip3.6 install -r ${PADDLE_ROOT}/python/requirements.txt
194 195 196
            elif [ "$1" == "cp37-cp37m" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.7.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.7.0/bin/:${PATH}
197
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.7.0/bin/python3.7
198 199
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.7.0/include/python3.7m
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.7.0/lib/libpython3.so"
200
                pip3.7 install -r ${PADDLE_ROOT}/python/requirements.txt
G
guofei 已提交
201 202 203 204 205 206 207
            elif [ "$1" == "cp38-cp38" ]; then
                export LD_LIBRARY_PATH=/opt/_internal/cpython-3.8.0/lib/:${LD_LIBRARY_PATH}
                export PATH=/opt/_internal/cpython-3.8.0/bin/:${PATH}
                export PYTHON_FLAGS="-DPYTHON_EXECUTABLE:FILEPATH=/opt/_internal/cpython-3.8.0/bin/python3.8
            -DPYTHON_INCLUDE_DIR:PATH=/opt/_internal/cpython-3.8.0/include/python3.8
            -DPYTHON_LIBRARIES:FILEPATH=/opt/_internal/cpython-3.8.0/lib/libpython3.so"
                pip3.8 install -r ${PADDLE_ROOT}/python/requirements.txt
208
           fi
209 210
        else
            pip install -r ${PADDLE_ROOT}/python/requirements.txt
211 212
        fi
    fi
M
minqiyang 已提交
213

J
JiabinYang 已提交
214
    if [ "$SYSTEM" == "Darwin" ]; then
T
tangwei12 已提交
215
        WITH_DISTRIBUTE="OFF"
216
        WITH_AVX=${WITH_AVX:-ON}
J
Jiabin Yang 已提交
217
        INFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR:-~/.cache/inference_demo}
J
JiabinYang 已提交
218
    else
J
Jiabin Yang 已提交
219
        INFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR:-/root/.cache/inference_demo}
220
    fi
M
minqiyang 已提交
221

G
gongweibao 已提交
222
    distibuted_flag=${WITH_DISTRIBUTE:-OFF}
T
tangwei12 已提交
223 224
    grpc_flag="OFF"
    gloo_flag=${distibuted_flag}
225

226 227 228 229 230 231
    cat <<EOF
    ========================================
    Configuring cmake in /paddle/build ...
        -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE:-Release}
        ${PYTHON_FLAGS}
        -DWITH_GPU=${WITH_GPU:-OFF}
232
        -DWITH_TENSORRT=${WITH_TENSORRT:-ON}
233
        -DWITH_AMD_GPU=${WITH_AMD_GPU:-OFF}
G
gongweibao 已提交
234
        -DWITH_DISTRIBUTE=${distibuted_flag}
235 236 237 238 239 240
        -DWITH_MKL=${WITH_MKL:-ON}
        -DWITH_AVX=${WITH_AVX:-OFF}
        -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-All}
        -DWITH_PYTHON=${WITH_PYTHON:-ON}
        -DCUDNN_ROOT=/usr/
        -DWITH_TESTING=${WITH_TESTING:-ON}
241
        -DWITH_COVERAGE=${WITH_COVERAGE:-OFF}
242
        -DWITH_INCREMENTAL_COVERAGE=${WITH_INCREMENTAL_COVERAGE:-OFF}
243 244 245 246 247
        -DCMAKE_MODULE_PATH=/opt/rocm/hip/cmake
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON
        -DWITH_CONTRIB=${WITH_CONTRIB:-ON}
        -DWITH_INFERENCE_API_TEST=${WITH_INFERENCE_API_TEST:-ON}
248
        -DINFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR}
249
        -DPY_VERSION=${PY_VERSION:-2.7}
W
Wu Yi 已提交
250
        -DCMAKE_INSTALL_PREFIX=${INSTALL_PREFIX:-/paddle/build}
G
gongweibao 已提交
251
        -DWITH_GRPC=${grpc_flag}
T
tangwei12 已提交
252
        -DWITH_PSCORE=${distibuted_flag}
253
        -DWITH_GLOO=${gloo_flag}
石晓伟 已提交
254
        -DWITH_LITE=${WITH_LITE:-OFF}
T
tianshuo78520a 已提交
255
        -DWITH_XPU=${WITH_XPU:-OFF}
256
        -DLITE_GIT_TAG=release/v2.8
257
        -DWITH_UNITY_BUILD=${WITH_UNITY_BUILD:-OFF}
258
        -DWITH_XPU_BKCL=${WITH_XPU_BKCL:-OFF}
259
    ========================================
260
EOF
261 262 263
    # Disable UNITTEST_USE_VIRTUALENV in docker because
    # docker environment is fully controlled by this script.
    # See /Paddle/CMakeLists.txt, UNITTEST_USE_VIRTUALENV option.
Z
zhangchunle 已提交
264
    set +e
265 266 267 268
    cmake .. \
        -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE:-Release} \
        ${PYTHON_FLAGS} \
        -DWITH_GPU=${WITH_GPU:-OFF} \
269
        -DWITH_TENSORRT=${WITH_TENSORRT:-ON} \
270
        -DWITH_AMD_GPU=${WITH_AMD_GPU:-OFF} \
G
gongweibao 已提交
271
        -DWITH_DISTRIBUTE=${distibuted_flag} \
272 273
        -DWITH_MKL=${WITH_MKL:-ON} \
        -DWITH_AVX=${WITH_AVX:-OFF} \
274
        -DNOAVX_CORE_FILE=${NOAVX_CORE_FILE:-""} \
275 276 277 278
        -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-All} \
        -DWITH_PYTHON=${WITH_PYTHON:-ON} \
        -DCUDNN_ROOT=/usr/ \
        -DWITH_TESTING=${WITH_TESTING:-ON} \
279
        -DWITH_COVERAGE=${WITH_COVERAGE:-OFF} \
280
        -DWITH_INCREMENTAL_COVERAGE=${WITH_INCREMENTAL_COVERAGE:-OFF} \
281 282 283 284
        -DCMAKE_MODULE_PATH=/opt/rocm/hip/cmake \
        -DCMAKE_EXPORT_COMPILE_COMMANDS=ON \
        -DWITH_CONTRIB=${WITH_CONTRIB:-ON} \
        -DWITH_INFERENCE_API_TEST=${WITH_INFERENCE_API_TEST:-ON} \
Z
zhangchunle 已提交
285
        -DINFERENCE_DEMO_INSTALL_DIR=${INFERENCE_DEMO_INSTALL_DIR} \
W
Wu Yi 已提交
286
        -DPY_VERSION=${PY_VERSION:-2.7} \
M
minqiyang 已提交
287
        -DCMAKE_INSTALL_PREFIX=${INSTALL_PREFIX:-/paddle/build} \
石晓伟 已提交
288
        -DWITH_GRPC=${grpc_flag} \
T
tangwei12 已提交
289
        -DWITH_PSCORE=${distibuted_flag} \
290
        -DWITH_GLOO=${gloo_flag} \
291
        -DLITE_GIT_TAG=release/v2.8 \
T
tianshuo78520a 已提交
292
        -DWITH_XPU=${WITH_XPU:-OFF} \
W
Wilber 已提交
293
        -DXPU_SDK_ROOT=${XPU_SDK_ROOT:-""} \
294
        -DWITH_LITE=${WITH_LITE:-OFF} \
295
        -DWITH_XPU_BKCL=${WITH_XPU_BKCL:-OFF} \
296
        -DWITH_UNITY_BUILD=${WITH_UNITY_BUILD:-OFF};build_error=$?
Z
zhangchunle 已提交
297 298 299
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
300 301
}

302 303 304 305 306 307
function cmake_gen() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cmake_base $1
}

C
chalsliu 已提交
308 309 310 311
function cmake_gen_in_current_dir() {
    cmake_base $1
}

312 313 314
function abort(){
    echo "Your change doesn't follow PaddlePaddle's code style." 1>&2
    echo "Please use pre-commit to check what is wrong." 1>&2
315
    exit 4
316 317 318 319 320 321
}

function check_style() {
    trap 'abort' 0
    set -e

322 323 324
    if [ -x "$(command -v gimme)" ]; then
    	eval "$(GIMME_GO_VERSION=1.8.3 gimme)"
    fi
325

326 327

    pip install cpplint pylint pytest astroid isort
328 329 330 331 332 333 334
    # set up go environment for running gometalinter
    mkdir -p $GOPATH/src/github.com/PaddlePaddle/
    ln -sf ${PADDLE_ROOT} $GOPATH/src/github.com/PaddlePaddle/Paddle

    pre-commit install
    clang-format --version

T
tianshuo78520a 已提交
335
    commit_files=on
336 337
    for file_name in `git diff --numstat upstream/$BRANCH |awk '{print $NF}'`;do
        if ! pre-commit run --files $file_name ; then
T
tianshuo78520a 已提交
338
            commit_files=off
339 340
        fi
    done 
T
tianshuo78520a 已提交
341 342 343
    
    if [ $commit_files == 'off' ];then
        echo "code format error"
344
        git diff 2>&1
345
        exit 4
T
tianshuo78520a 已提交
346
    fi
347 348 349 350 351 352 353
    trap : 0
}

#=================================================
#              Build
#=================================================

354
function build_base() {
Z
zhangchunle 已提交
355
    set +e
356
    if [ "$SYSTEM" == "Linux" ];then
357
      if [ `nproc` -gt 16 ];then
358
          parallel_number=$(expr `nproc` - 8)
359 360 361
      else
          parallel_number=`nproc`
      fi
362 363 364 365
    else
      parallel_number=8
    fi
    if [ "$1" != "" ]; then
366 367
      parallel_number=$1
    fi
Z
Zeng Jinle 已提交
368 369 370 371 372

    if [[ "$ENABLE_MAKE_CLEAN" != "OFF" ]]; then
        make clean
    fi

L
LoveAn 已提交
373 374 375
    # reset ccache zero stats for collect PR's actual hit rate
    ccache -z

Z
zhangchunle 已提交
376
    make install -j ${parallel_number};build_error=$?
L
LoveAn 已提交
377 378 379 380

    # ci will collect ccache hit rate
    collect_ccache_hits

Z
zhangchunle 已提交
381 382 383
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
384 385
}

Z
zhangchunle 已提交
386 387 388 389 390 391
function build_size() {
    cat <<EOF
    ============================================
    Calculate /paddle/build size and PR whl size
    ============================================
EOF
392
    if [ "$1" == "paddle_inference" ]; then
Z
zhangchunle 已提交
393
        cd ${PADDLE_ROOT}/build
394 395 396 397
        cp -r paddle_inference_install_dir paddle_inference
        tar -czf paddle_inference.tgz paddle_inference
        buildSize=$(du -h --max-depth=0 ${PADDLE_ROOT}/build/paddle_inference.tgz |awk '{print $1}')
        echo "Paddle_Inference Size: $buildSize"
398
        echo "ipipe_log_param_Paddle_Inference_Size: $buildSize"
Z
zhangchunle 已提交
399 400 401 402 403 404 405 406 407
    else
        SYSTEM=`uname -s`
        if [ "$SYSTEM" == "Darwin" ]; then
            com='du -h -d 0'
        else
            com='du -h --max-depth=0'
        fi
        buildSize=$($com ${PADDLE_ROOT}/build |awk '{print $1}')
        echo "Build Size: $buildSize"
408
        echo "ipipe_log_param_Build_Size: $buildSize"
Z
zhangchunle 已提交
409 410
        PR_whlSize=$($com ${PADDLE_ROOT}/build/python/dist |awk '{print $1}')
        echo "PR whl Size: $PR_whlSize"
411
        echo "ipipe_log_param_PR_whl_Size: $PR_whlSize"
Z
zhangchunle 已提交
412 413 414
    fi
}

415 416 417 418 419 420 421 422
function build() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ============================================
    Building in /paddle/build ...
    ============================================
EOF
Z
Zeng Jinle 已提交
423
    build_base $@
Z
zhangchunle 已提交
424 425 426 427 428 429 430 431 432 433 434 435
    current_branch=`git branch | grep \* | cut -d ' ' -f2`
    if [ "$current_branch" != "develop_base_pr" ];then
        build_size
    fi
}

function cmake_gen_and_build() {
    startTime_s=`date +%s`
    cmake_gen $1
    build $2
    endTime_s=`date +%s`
    echo "Build Time: $[ $endTime_s - $startTime_s ]s"
436
    echo "ipipe_log_param_Build_Time: $[ $endTime_s - $startTime_s ]s"
437 438
}

439
function build_mac() {
Z
zhangchunle 已提交
440
    set +e
441 442 443 444 445 446 447
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ============================================
    Building in /paddle/build ...
    ============================================
EOF
Z
Zeng Jinle 已提交
448 449 450
    if [[ "$ENABLE_MAKE_CLEAN" != "OFF" ]]; then
        make clean
    fi
L
LoveAn 已提交
451 452 453 454

    # reset ccache zero stats for collect PR's actual hit rate
    ccache -z

Z
zhangchunle 已提交
455
    make install -j 8;build_error=$?
L
LoveAn 已提交
456 457 458 459

    # ci will collect ccache hit rate
    collect_ccache_hits

Z
zhangchunle 已提交
460 461 462
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
L
LoveAn 已提交
463

Z
zhangchunle 已提交
464
    set -e
Z
zhangchunle 已提交
465 466 467 468 469 470 471 472 473
    build_size
}

function cmake_gen_and_build_mac() {
    startTime_s=`date +%s`
    cmake_gen $1
    build_mac
    endTime_s=`date +%s`
    echo "Build Time: $[ $endTime_s - $startTime_s ]s"
474
    echo "ipipe_log_param_Build_Time: $[ $endTime_s - $startTime_s ]s"
475 476
}

477 478 479 480 481 482 483 484 485
function run_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit tests ...
    ========================================
EOF
486 487 488 489 490
        if [ ${TESTING_DEBUG_MODE:-OFF} == "ON" ] ; then
            ctest -V
        else
            ctest --output-on-failure
        fi
491 492 493
    fi
}

494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512

function combine_avx_noavx_build() {
    mkdir -p ${PADDLE_ROOT}/build.noavx
    cd ${PADDLE_ROOT}/build.noavx
    WITH_AVX=OFF
    cmake_base ${PYTHON_ABI:-""}
    build_base

    # build combined one
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    NOAVX_CORE_FILE=`find ${PADDLE_ROOT}/build.noavx/python/paddle/fluid/ -name "core_noavx.*"`
    WITH_AVX=ON

    cmake_base ${PYTHON_ABI:-""}
    build_base
}


G
gongweibao 已提交
513 514 515 516 517 518 519 520 521 522 523 524
function run_brpc_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [[ ${WITH_TESTING:-ON} == "ON" \
        && ${WITH_DISTRIBUTE:-OFF} == "ON" \
        && ${WITH_GRPC:-OFF} == "OFF" ]] ; then
    cat <<EOF
    ========================================
    Running brpc unit tests ...
    ========================================
EOF
        set +x
525 526
        declare -a other_tests=("test_listen_and_serv_op" "system_allocator_test" \
        "rpc_server_test" "varhandle_test" "collective_server_test" "brpc_serde_test")
G
gongweibao 已提交
527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552
        all_tests=`ctest -N`

        for t in "${other_tests[@]}"
        do
            if [[ ${all_tests} != *$t* ]]; then
                continue
            fi

            if [[ ${TESTING_DEBUG_MODE:-OFF} == "ON" ]] ; then
                ctest -V -R $t
            else
                ctest --output-on-failure -R $t
            fi
        done
        set -x

        if [[ ${TESTING_DEBUG_MODE:-OFF} == "ON" ]] ; then
            ctest -V -R test_dist_*
        else
            ctest --output-on-failure -R test_dist_*
        fi
    fi
}



553 554 555 556 557 558 559 560 561
function run_mac_test() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit tests ...
    ========================================
EOF
562 563
        #remove proxy here to fix dist ut 'test_fl_listen_and_serv_op' error on mac. 
        #see details: https://github.com/PaddlePaddle/Paddle/issues/24738
T
tianshuo78520a 已提交
564
        set +x
565
        my_proxy=$http_proxy
J
JiabinYang 已提交
566 567
        export http_proxy=
        export https_proxy=
T
tianshuo78520a 已提交
568
        set -x
569 570 571 572 573 574 575 576 577 578

        set +ex
        if [ "$1" == "cp27-cp27m" ]; then
            pip uninstall -y paddlepaddle
        elif [ "$1" == "cp35-cp35m" ]; then
            pip3.5 uninstall -y paddlepaddle
        elif [ "$1" == "cp36-cp36m" ]; then
            pip3.6 uninstall -y paddlepaddle
        elif [ "$1" == "cp37-cp37m" ]; then
            pip3.7 uninstall -y paddlepaddle
G
guofei 已提交
579 580
        elif [ "$1" == "cp38-cp38" ]; then
            pip3.8 uninstall -y paddlepaddle
581 582 583
        fi
        set -ex

584
        if [ "$1" == "cp27-cp27m" ]; then
585
            set -e
586
            pip install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
J
JiabinYang 已提交
587
            python ${PADDLE_ROOT}/paddle/scripts/installation_validate.py
588 589 590 591 592 593
        elif [ "$1" == "cp35-cp35m" ]; then
            pip3.5 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
        elif [ "$1" == "cp36-cp36m" ]; then
            pip3.6 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
        elif [ "$1" == "cp37-cp37m" ]; then
            pip3.7 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
G
guofei 已提交
594 595
        elif [ "$1" == "cp38-cp38" ]; then
            pip3.8 install --user ${INSTALL_PREFIX:-/paddle/build}/opt/paddle/share/wheels/*.whl
596
        fi
597 598
        tmpfile_rand=`date +%s%N`
        tmpfile=$tmp_dir/$tmpfile_rand
Y
YUNSHEN XIE 已提交
599
        set +ex
Z
zhangchunle 已提交
600
        ut_startTime_s=`date +%s`
Y
YUNSHEN XIE 已提交
601
        get_quickly_disable_ut||disable_ut_quickly='' # indicate whether the case was in quickly disable list 
602 603 604
        if [ ${NIGHTLY_MODE:-OFF} == "ON" ]; then
            nightly_label=""
        else
605
            nightly_label="(RUN_TYPE=NIGHTLY|RUN_TYPE=DIST:NIGHTLY|RUN_TYPE=EXCLUSIVE:NIGHTLY)"
606 607 608 609
            echo "========================================="
            echo "Unittests with nightly labels  are only run at night"
            echo "========================================="
        fi
Y
YUNSHEN XIE 已提交
610 611 612 613 614 615 616 617 618 619
        bash $PADDLE_ROOT/tools/check_added_ut.sh
        get_precision_ut_mac
        if [[ "$on_precision" == "0" ]];then
            ctest -E "($disable_ut_quickly)" -LE ${nightly_label} --output-on-failure -j $2 | tee $tmpfile
        else
            ctest -R "($UT_list_prec)" -E "($disable_ut_quickly)" -LE ${nightly_label} --output-on-failure -j $2 | tee $tmpfile
            tmpfile_rand=`date +%s%N`
            tmpfile=$tmp_dir/$tmpfile_rand
            ctest -R "($UT_list_prec_1)" -E "($disable_ut_quickly)" -LE ${nightly_label} --output-on-failure -j $2 | tee $tmpfile
        fi
620 621 622 623 624 625 626
        failed_test_lists=''
        collect_failed_tests
        mactest_error=0
        retry_unittests_record=''
        retry_time=3
        exec_times=0
        exec_time_array=('first' 'second' 'third')
627 628
        exec_retry_threshold=10
        is_retry_execuate=0
629 630
        if [ -n "$failed_test_lists" ];then
            mactest_error=1
631 632 633
            read need_retry_ut_str <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(" | sed 's/(//' | sed 's/- //' )
            need_retry_ut_arr=(${need_retry_ut_str})
            need_retry_ut_count=${#need_retry_ut_arr[@]}
634
            read retry_unittests <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(" | sed 's/(//' | sed 's/- //' )
635
            if [ $need_retry_ut_count -lt $exec_retry_threshold ];then
636
                while ( [ $exec_times -lt $retry_time ] )
637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662
                    do
                        retry_unittests_record="$retry_unittests_record$failed_test_lists"
                        failed_test_lists_ult=`echo "${failed_test_lists}"`
                        echo "========================================="
                        echo "This is the ${exec_time_array[$exec_times]} time to re-run"
                        echo "========================================="
                        echo "The following unittest will be re-run:"
                        echo "${retry_unittests}"
                        echo "========================================="

                        retry_unittests_regular=''
                        for line in ${retry_unittests[@]} ;
                            do
                                if [[ "$retry_unittests_regular" == "" ]];then
                                    retry_unittests_regular="^$line$"
                                else
                                    retry_unittests_regular="$retry_unittests_regular|^$line$"
                                fi
                            done
                        rm -f $tmp_dir/*
                        failed_test_lists=''
                        ctest -R "($retry_unittests_regular)" --output-on-failure -j $2 | tee $tmpfile
                        collect_failed_tests
                        exec_times=$[$exec_times+1]
                    done
            else
663 664
                # There are more than 10 failed unit tests, so no unit test retry
                is_retry_execuate=1
665 666
            fi

667 668
        fi
        #mactest_error=$?
Z
zhangchunle 已提交
669 670
        ut_endTime_s=`date +%s`
        echo "Mac testCase Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
671
        echo "ipipe_log_param_Mac_TestCases_Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
T
Tao Luo 已提交
672
        paddle version
673
        # Recovery proxy to avoid failure in later steps
T
tianshuo78520a 已提交
674
        set +x
675 676
        export http_proxy=$my_proxy
        export https_proxy=$my_proxy
677
        if [ "$mactest_error" != 0 ];then
678
            show_ut_retry_result
679
        fi
680
        set -x
681 682 683
    fi
}

Y
YUNSHEN XIE 已提交
684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719
function get_precision_ut_mac() {
    on_precision=0
    set -x
    UT_list=$(ctest -N | awk -F ': ' '{print $2}' | sed '/^$/d' | sed '$d')
    precison_cases=""
    if [ ${PRECISION_TEST:-OFF} == "ON" ]; then
        python3.7 $PADDLE_ROOT/tools/get_pr_ut.py
        if [[ -f "ut_list" ]]; then
            set +x
            echo "PREC length: "`wc -l ut_list`
            precision_cases=`cat ut_list`
            set -x
        fi
    fi
    if [ ${PRECISION_TEST:-OFF} == "ON" ] && [[ "$precision_cases" != "" ]];then
        UT_list_re=''
        on_precision=1
        re=$(cat ut_list|awk -F ' ' '{print }' | awk 'BEGIN{ all_str=""}{if (all_str==""){all_str=$1}else{all_str=all_str"$|^"$1}} END{print "^"all_str"$"}')
        UT_list_prec_1='ut_list_prec2'
        for case in $UT_list; do
            flag=$(echo $case|grep -oE $re)
            if [ -n "$flag" ];then
                if [ -z "$UT_list_prec" ];then
                    UT_list_prec="^$case$"
                elif [[ "${#UT_list_prec}" -gt 10000 ]];then
                    UT_list_prec_1="$UT_list_prec_1|^$case$"
                else
                    UT_list_prec="$UT_list_prec|^$case$"
                fi
            else
                echo ${case} "won't run in PRECISION_TEST mode."
            fi
        done
    fi
}

Z
Zeng Jinle 已提交
720 721 722 723 724 725 726 727 728 729 730 731 732 733
function fetch_upstream_develop_if_not_exist() {
    UPSTREAM_URL='https://github.com/PaddlePaddle/Paddle'
    origin_upstream_url=`git remote -v | awk '{print $1, $2}' | uniq | grep upstream | awk '{print $2}'` 
    if [ "$origin_upstream_url" == "" ]; then
        git remote add upstream $UPSTREAM_URL.git
    elif [ "$origin_upstream_url" != "$UPSTREAM_URL" ] \
            && [ "$origin_upstream_url" != "$UPSTREAM_URL.git" ]; then
        git remote remove upstream
        git remote add upstream $UPSTREAM_URL.git
    fi
    
    if [ ! -e "$PADDLE_ROOT/.git/refs/remotes/upstream/$BRANCH" ]; then 
        git fetch upstream # develop is not fetched
    fi
Z
Zeng Jinle 已提交
734
}
Z
Zeng Jinle 已提交
735 736 737

function generate_upstream_develop_api_spec() {
    fetch_upstream_develop_if_not_exist
Z
Zeng Jinle 已提交
738
    cur_branch=`git branch | grep \* | cut -d ' ' -f2`
739
    git checkout .
Z
Zeng Jinle 已提交
740 741 742
    git checkout -b develop_base_pr upstream/$BRANCH
    cmake_gen $1
    build $2
743
    cp ${PADDLE_ROOT}/python/requirements.txt /tmp
Z
Zeng Jinle 已提交
744

Z
Zeng Jinle 已提交
745
    git checkout $cur_branch
Z
Zeng Jinle 已提交
746
    generate_api_spec "$1" "DEV"
747
    git branch -D develop_base_pr
748 749
    ENABLE_MAKE_CLEAN="ON"
    rm -rf ${PADDLE_ROOT}/build/Makefile ${PADDLE_ROOT}/build/CMakeCache.txt
750 751 752 753
    cmake_change=`git diff --name-only upstream/$BRANCH | grep "cmake/external" || true`
    if [ ${cmake_change} ];then
        rm -rf ${PADDLE_ROOT}/build/third_party
    fi
Z
Zeng Jinle 已提交
754 755 756
}

function generate_api_spec() {
T
tianshuo78520a 已提交
757
    set -e
Z
Zeng Jinle 已提交
758 759 760 761 762 763
    spec_kind=$2
    if [ "$spec_kind" != "PR" ] && [ "$spec_kind" != "DEV" ]; then
        echo "Not supported $2"
        exit 1
    fi

Y
yuyang18 已提交
764 765
    mkdir -p ${PADDLE_ROOT}/build/.check_api_workspace
    cd ${PADDLE_ROOT}/build/.check_api_workspace
Z
Zeng Jinle 已提交
766 767
    virtualenv .${spec_kind}_env
    source .${spec_kind}_env/bin/activate
768 769 770 771 772 773

    if [ "$spec_kind" == "DEV" ]; then
        pip install -r /tmp/requirements.txt
    else
        pip install -r ${PADDLE_ROOT}/python/requirements.txt
    fi
T
Tao Luo 已提交
774
    pip --no-cache-dir install ${PADDLE_ROOT}/build/python/dist/*whl
775
    spec_path=${PADDLE_ROOT}/paddle/fluid/API_${spec_kind}.spec
Z
Zeng Jinle 已提交
776
    python ${PADDLE_ROOT}/tools/print_signatures.py paddle > $spec_path
777

778 779 780
    # used to log op_register data_type
    op_type_path=${PADDLE_ROOT}/paddle/fluid/OP_TYPE_${spec_kind}.spec
    python ${PADDLE_ROOT}/tools/check_op_register_type.py > $op_type_path
781 782 783 784 785

    # print all ops desc in dict to op_desc_path
    op_desc_path=${PADDLE_ROOT}/paddle/fluid/OP_DESC_${spec_kind}.spec
    python ${PADDLE_ROOT}/tools/print_op_desc.py > $op_desc_path

786 787 788 789
    # print api and the md5 of source code of the api.
    api_source_md5_path=${PADDLE_ROOT}/paddle/fluid/API_${spec_kind}.source.md5
    python ${PADDLE_ROOT}/tools/count_api_without_core_ops.py -p paddle > $api_source_md5_path

T
tianshuo78520a 已提交
790 791
    awk -F '(' '{print $NF}' $spec_path >${spec_path}.doc
    awk -F '(' '{$NF="";print $0}' $spec_path >${spec_path}.api
G
guofei 已提交
792
    if [ "$1" == "cp35-cp35m" ] || [ "$1" == "cp36-cp36m" ] || [ "$1" == "cp37-cp37m" ] || [ "$1" == "cp38-cp38" ]; then
M
minqiyang 已提交
793
        # Use sed to make python2 and python3 sepc keeps the same
Z
Zeng Jinle 已提交
794 795 796
        sed -i 's/arg0: str/arg0: unicode/g' $spec_path
        sed -i "s/\(.*Transpiler.*\).__init__ (ArgSpec(args=\['self'].*/\1.__init__ /g" $spec_path
    fi   
Z
Zeng Jinle 已提交
797 798 799
    
    python ${PADDLE_ROOT}/tools/diff_use_default_grad_op_maker.py \
        ${PADDLE_ROOT}/paddle/fluid/op_use_default_grad_maker_${spec_kind}.spec
S
sneaxiy 已提交
800

Y
yuyang18 已提交
801
    deactivate
802 803
}

804
function check_approvals_of_unittest() {
I
iducn 已提交
805
    set +x
806 807 808
    if [ "$GITHUB_API_TOKEN" == "" ] || [ "$GIT_PR_ID" == "" ]; then
        return 0
    fi
809 810
    # approval_user_list: XiaoguangHu01 46782768,luotao1 6836917,phlrain 43953930,lanxianghit 47554610, zhouwei25 52485244, kolinwei 22165420
    check_times=$1
811 812
    if [ $check_times == 1 ]; then
        approval_line=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000`
813
        if [ "${approval_line}" != "" ]; then
814
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 22165420 52485244`
815 816 817 818 819 820 821
            echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
            if [ "${APPROVALS}" == "TRUE" ]; then
                echo "==================================="
                echo -e "\n current pr ${GIT_PR_ID} has got approvals. So, Pass CI directly!\n"
                echo "==================================="
                exit 0
            fi
822
        fi
823
    elif [ $check_times == 2 ]; then
824 825
        unittest_spec_diff=`python ${PADDLE_ROOT}/tools/diff_unittest.py ${PADDLE_ROOT}/paddle/fluid/UNITTEST_DEV.spec ${PADDLE_ROOT}/paddle/fluid/UNITTEST_PR.spec`
        if [ "$unittest_spec_diff" != "" ]; then
826
            approval_line=`curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000`
827
            APPROVALS=`echo ${approval_line}|python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 22165420 52485244 32428676 45041955`
828 829 830 831 832
            echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
            if [ "${APPROVALS}" == "FALSE" ]; then
                echo "************************************"
                echo -e "It is forbidden to disable or delete the unit-test.\n"
                echo -e "If you must delete it temporarily, please add it to[https://github.com/PaddlePaddle/Paddle/wiki/Temporarily-disabled-Unit-Test]."
833
                echo -e "Then you must have one RD (kolinwei(recommended), chalsliu, XieYunshen or zhouwei25) approval for the deletion of unit-test. \n"
834 835 836 837 838
                echo -e "If you have any problems about deleting unit-test, please read the specification [https://github.com/PaddlePaddle/Paddle/wiki/Deleting-unit-test-is-forbidden]. \n"
                echo -e "Following unit-tests are deleted in this PR: \n ${unittest_spec_diff} \n"
                echo "************************************"
                exit 1
            fi
839 840
        fi
    fi
841
    set -x
842 843
}

844 845 846 847 848 849 850 851 852 853
function check_diff_file_for_coverage() {
    diff_h_file=$(git diff --name-status test develop | awk '$1 != "D" {print $2}' | grep '\.h$' | awk -F "/" '{printf "%s,",$NF}')
    diff_cc_file=$(git diff --name-status test develop | awk '$1 != "D" {print $2}' | grep -E '\.(cc|c)$' | awk -F "/" '{printf "%s,",$NF}')
    diff_py_file=$(git diff --name-status test develop | grep '\.py$' | awk '$1 != "D" {printf "%s,",$2}')

    export PADDLE_GIT_DIFF_H_FILE=${diff_h_file%*,}
    export PADDLE_GIT_DIFF_CC_FILE=${diff_cc_file%*,}
    export PADDLE_GIT_DIFF_PY_FILE=${diff_py_file%*,}
}

854 855 856 857 858 859 860
function check_change_of_unittest() {
    generate_unittest_spec "PR"
    fetch_upstream_develop_if_not_exist
    git reset --hard upstream/$BRANCH
    cmake_gen $1
    generate_unittest_spec "DEV"
    check_approvals_of_unittest 2
861 862
}

863 864 865 866
function check_sequence_op_unittest(){
    /bin/bash ${PADDLE_ROOT}/tools/check_sequence_op.sh
}

867 868 869 870
function generate_unittest_spec() {
    spec_kind=$1
    if [ "$spec_kind" == "DEV" ]; then
        cat <<EOF
871 872 873
        ============================================
        Generate unit tests.spec of develop.
        ============================================
874 875 876
EOF
    elif [ "$spec_kind" == "PR" ]; then
        cat <<EOF
877 878 879
        ============================================
        Generate unit tests.spec of this PR.
        ============================================
880 881 882 883 884
EOF
    else
        echo "Not supported $1"
        exit 1
    fi
885
    spec_path=${PADDLE_ROOT}/paddle/fluid/UNITTEST_${spec_kind}.spec
886 887 888
    ctest -N | awk -F ':' '{print $2}' | sed '/^$/d' | sed '$d' > ${spec_path}
}

Z
Zeng Jinle 已提交
889

890
function assert_api_spec_approvals() {
Z
zhangchunle 已提交
891 892 893
    /bin/bash ${PADDLE_ROOT}/tools/check_api_approvals.sh;approval_error=$?
    if [ "$approval_error" != 0 ];then
       exit 6
894
    fi
Y
yuyang18 已提交
895 896
}

Z
zhangchunle 已提交
897 898 899 900 901 902 903
function assert_file_diff_approvals() {
    /bin/bash ${PADDLE_ROOT}/tools/check_file_diff_approvals.sh;file_approval_error=$?
    if [ "$file_approval_error" != 0 ];then
       exit 6
    fi
}

Y
yuyang18 已提交
904

L
Liu Xudong 已提交
905 906 907 908 909
function check_coverage() {
    /bin/bash ${PADDLE_ROOT}/tools/coverage/paddle_coverage.sh
}


910 911 912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927 928
function single_test() {
    TEST_NAME=$1
    if [ -z "${TEST_NAME}" ]; then
        echo -e "${RED}Usage:${NONE}"
        echo -e "${BOLD}${SCRIPT_NAME}${NONE} ${BLUE}single_test${NONE} [test_name]"
        exit 1
    fi
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running ${TEST_NAME} ...
    ========================================
EOF
        ctest --output-on-failure -R ${TEST_NAME}
    fi
}

929 930 931
function bind_test() {
    # the number of process to run tests
    NUM_PROC=6
Q
Qiyang Min 已提交
932

933 934 935
    # calculate and set the memory usage for each process
    MEM_USAGE=$(printf "%.2f" `echo "scale=5; 1.0 / $NUM_PROC" | bc`)
    export FLAGS_fraction_of_gpu_memory_to_use=$MEM_USAGE
Q
Qiyang Min 已提交
936

937 938
    # get the CUDA device count
    CUDA_DEVICE_COUNT=$(nvidia-smi -L | wc -l)
Q
Qiyang Min 已提交
939

940 941 942 943 944 945 946 947 948 949 950 951 952 953 954 955 956 957 958
    for (( i = 0; i < $NUM_PROC; i++ )); do
        cuda_list=()
        for (( j = 0; j < $CUDA_DEVICE_COUNT; j++ )); do
            s=$[i+j]
            n=$[s%CUDA_DEVICE_COUNT]
            if [ $j -eq 0 ]; then
                cuda_list=("$n")
            else
                cuda_list="$cuda_list,$n"
            fi
        done
        echo $cuda_list
        # CUDA_VISIBLE_DEVICES http://acceleware.com/blog/cudavisibledevices-masking-gpus
        # ctest -I https://cmake.org/cmake/help/v3.0/manual/ctest.1.html?highlight=ctest
        env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC --output-on-failure &
    done
    wait
}

959 960 961 962 963 964 965 966 967 968 969
EXIT_CODE=0;
function caught_error() {
 for job in `jobs -p`; do
        # echo "PID => ${job}"
        if ! wait ${job} ; then
            echo "At least one test failed with exit code => $?" ;
            EXIT_CODE=1;
        fi
    done
}

Z
zhangchunle 已提交
970 971 972 973 974 975 976 977 978 979
function case_count(){
    cat <<EOF
    ============================================
    Generating TestCases Count ... 
    ============================================
EOF
    testcases=$1
    num=$(echo $testcases|grep -o '\^'|wc -l)
    if [ "$2" == "" ]; then
        echo "exclusive TestCases count is $num"
980
        echo "ipipe_log_param_Exclusive_TestCases_Count: $num"
Z
zhangchunle 已提交
981 982
    else
        echo "$2 card TestCases count is $num"
Z
zhangchunle 已提交
983
        echo "ipipe_log_param_${2}_Cards_TestCases_Count: $num"
Z
zhangchunle 已提交
984 985 986
    fi
}

Z
zhangchunle 已提交
987 988 989 990 991 992 993 994 995 996 997 998 999 1000 1001 1002 1003
failed_test_lists=''
tmp_dir=`mktemp -d`

function collect_failed_tests() {
    for file in `ls $tmp_dir`; do
        exit_code=0
        grep -q 'The following tests FAILED:' $tmp_dir/$file||exit_code=$?
        if [ $exit_code -ne 0 ]; then
            failuretest=''
        else
            failuretest=`grep -A 10000 'The following tests FAILED:' $tmp_dir/$file | sed 's/The following tests FAILED://g'|sed '/^$/d'`
            failed_test_lists="${failed_test_lists}
            ${failuretest}"
        fi
    done
}

Y
YUNSHEN XIE 已提交
1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016
# getting qucik disable ut list 
function get_quickly_disable_ut() {
    python -m pip install requests
    if disable_ut_quickly=$(python ${PADDLE_ROOT}/tools/get_quick_disable_lt.py); then
        echo "========================================="
        echo "The following unittests have been disabled:"
        echo ${disable_ut_quickly}
        echo "========================================="
    else
        disable_ut_quickly=''
    fi
}

1017 1018
function card_test() {
    set -m
Z
zhangchunle 已提交
1019 1020
    case_count $1 $2
    ut_startTime_s=`date +%s` 
1021
    # get the CUDA device count, XPU device count is one
T
tianshuo78520a 已提交
1022
    if [ "${WITH_XPU}" == "ON" ];then
1023
        CUDA_DEVICE_COUNT=1
T
tianshuo78520a 已提交
1024 1025 1026
    else
        CUDA_DEVICE_COUNT=$(nvidia-smi -L | wc -l)
    fi
1027 1028

    testcases=$1
1029
    parallel_level_base=${CTEST_PARALLEL_LEVEL:-1}
1030 1031 1032 1033 1034
    if (( $# > 1 )); then
        cardnumber=$2
        if (( $cardnumber > $CUDA_DEVICE_COUNT )); then
            cardnumber=$CUDA_DEVICE_COUNT
        fi
1035
        if (( $# > 2 )); then
1036
            parallel_job=`expr $3 \* $parallel_level_base`
1037
        else
1038
            parallel_job=$parallel_level_base
1039
        fi
1040 1041
    else
        cardnumber=$CUDA_DEVICE_COUNT
1042
        parallel_job=$parallel_level_base
1043 1044 1045 1046 1047 1048 1049
    fi

    if [[ "$testcases" == "" ]]; then
        return 0
    fi

    trap 'caught_error' CHLD
Z
zhangchunle 已提交
1050
    tmpfile_rand=`date +%s%N`
1051
    NUM_PROC=$[CUDA_DEVICE_COUNT/$cardnumber]
1052 1053 1054
    echo "****************************************************************"
    echo "***These unittests run $parallel_job job each time with $cardnumber GPU***"
    echo "****************************************************************"
1055 1056 1057 1058 1059 1060 1061 1062 1063 1064 1065
    for (( i = 0; i < $NUM_PROC; i++ )); do
        # CUDA_VISIBLE_DEVICES http://acceleware.com/blog/cudavisibledevices-masking-gpus
        # ctest -I https://cmake.org/cmake/help/v3.0/manual/ctest.1.html?highlight=ctest
        cuda_list=()
        for (( j = 0; j < cardnumber; j++ )); do
            if [ $j -eq 0 ]; then
                    cuda_list=("$[i*cardnumber]")
                else
                    cuda_list="$cuda_list,$[i*cardnumber+j]"
            fi
        done
Z
zhangchunle 已提交
1066
        tmpfile=$tmp_dir/$tmpfile_rand"_"$i
1067 1068
        if [ ${TESTING_DEBUG_MODE:-OFF} == "ON" ] ; then
            if [[ $cardnumber == $CUDA_DEVICE_COUNT ]]; then
1069
                (ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" -V --timeout 120 -j $parallel_job | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
Z
zhangchunle 已提交
1070
            else  
1071
                (env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" --timeout 120 -V -j $parallel_job | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
1072 1073 1074
            fi
        else
            if [[ $cardnumber == $CUDA_DEVICE_COUNT ]]; then
1075
                (ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" --timeout 120 --output-on-failure  -j $parallel_job | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
1076
            else
1077
                (env CUDA_VISIBLE_DEVICES=$cuda_list ctest -I $i,,$NUM_PROC -R "($testcases)" -E "($disable_ut_quickly)" --timeout 120 --output-on-failure  -j $parallel_job | tee $tmpfile; test ${PIPESTATUS[0]} -eq 0) &
1078 1079 1080 1081
            fi
        fi
    done
    wait; # wait for all subshells to finish
Z
zhangchunle 已提交
1082 1083 1084
    ut_endTime_s=`date +%s`
    if [ "$2" == "" ]; then
        echo "exclusive TestCases Total Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
1085
        echo "ipipe_log_param_Exclusive_TestCases_Total_Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
Z
zhangchunle 已提交
1086 1087
    else
        echo "$2 card TestCases Total Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
1088
        echo "ipipe_log_param_${2}_Cards_TestCases_Total_Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
Z
zhangchunle 已提交
1089
    fi
1090
    set +m
1091 1092
}

T
tianshuo78520a 已提交
1093
function parallel_test_base_gpu() {
1094 1095 1096
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
1097
    Running unit tests in parallel way ...
1098 1099 1100
    ========================================
EOF

1101
set -x
C
chalsliu 已提交
1102
        precison_cases=""
1103
        bash $PADDLE_ROOT/tools/check_added_ut.sh
C
chalsliu 已提交
1104
        if [ ${PRECISION_TEST:-OFF} == "ON" ]; then
1105 1106 1107
            python3.7 $PADDLE_ROOT/tools/get_pr_ut.py
            if [[ -f "ut_list" ]]; then
                set +x
C
chalsliu 已提交
1108
                echo "PREC length: "`wc -l ut_list`
1109 1110 1111
                precision_cases=`cat ut_list`
                set -x
            fi
C
chalsliu 已提交
1112
        fi
1113 1114 1115 1116 1117 1118 1119 1120 1121 1122 1123 1124
        if [ -a "$PADDLE_ROOT/duplicate_ut" ];then
            duplicate_uts=$(cat $PADDLE_ROOT/duplicate_ut|sed -e 's/\r//g')
            if [[ "$duplicate_uts" != "" ]];then
                set +x
                echo "========================================"
                echo "The new unit test has the same name as the existing unit test"
                cat "$PADDLE_ROOT/duplicate_ut"
                echo "========================================"
                exit 102;
                set -x
            fi
        fi
1125 1126 1127 1128 1129 1130 1131 1132 1133 1134
        if [ -a "$PADDLE_ROOT/added_ut" ];then
            added_uts=^$(awk BEGIN{RS=EOF}'{gsub(/\n/,"$|^");print}' $PADDLE_ROOT/added_ut)$
            ctest -R "(${added_uts})" --output-on-failure --repeat-until-fail 3 --timeout 15;added_ut_error=$?
            if [ "$added_ut_error" != 0 ];then
                echo "========================================"
                echo "Added UT should not exceed 15 seconds"
                echo "========================================"
                exit 8;
            fi
        fi
1135
set +x
1136
        EXIT_CODE=0;
1137
        test_cases=$(ctest -N -V) # get all test cases
1138 1139 1140 1141 1142
        single_card_tests_eight_parallel='^job$'    # cases list which would run 8 job each time with single GPU
        single_card_tests_tetrad_parallel='^job$'   # cases list which would run 4 job each time with single GPU
        single_card_tests_non_parallel_1='^job$'    # cases list which would run 1 job each time with single GPU
        single_card_tests_non_parallel_2='^job$'    # cases list which would run 1 job each time with single GPU
        single_card_tests='^job$' # all cases list which would take one graph card
1143 1144 1145 1146
        exclusive_tests=''        # cases list which would be run exclusively
        multiple_card_tests=''    # cases list which would take multiple GPUs, most cases would be two GPUs
        is_exclusive=''           # indicate whether the case is exclusive type
        is_multicard=''           # indicate whether the case is multiple GPUs type
1147
        is_nightly=''             # indicate whether the case will only run at night
1148 1149 1150 1151 1152 1153 1154
        get_quickly_disable_ut||disable_ut_quickly=''    # indicate whether the case was in quickly disable list

        UT_list=$(ctest -N | awk -F ': ' '{print $2}' | sed '/^$/d' | sed '$d')
        output=$(python ${PADDLE_ROOT}/tools/parallel_UT_rule.py "${UT_list}")
        eight_parallel_job=$(echo $output | cut -d ";" -f 1)
        tetrad_parallel_jog=$(echo $output | cut -d ";" -f 2)
        non_parallel_job=$(echo $output | cut -d ";" -f 3)
1155 1156 1157 1158 1159 1160 1161 1162
        while read -r line; do
            if [[ "$line" == "" ]]; then
                continue
            fi
                read matchstr <<< $(echo "$line"|grep -oEi 'Test[ \t]+#')
                if [[ "$matchstr" == "" ]]; then
                    # Any test case with LABELS property would be parse here
                    # RUN_TYPE=EXCLUSIVE mean the case would run exclusively
1163
                    # RUN_TYPE=DIST mean the case would take two graph GPUs during runtime
1164
                    # RUN_TYPE=NIGHTLY or RUN_TYPE=DIST:NIGHTLY or RUN_TYPE=EXCLUSIVE:NIGHTLY means the case will ONLY run at night
1165 1166
                    read is_exclusive <<< $(echo "$line"|grep -oEi "RUN_TYPE=EXCLUSIVE")
                    read is_multicard <<< $(echo "$line"|grep -oEi "RUN_TYPE=DIST")
1167
                    read is_nightly <<< $(echo "$line"|grep -oEi "RUN_TYPE=NIGHTLY|RUN_TYPE=DIST:NIGHTLY|RUN_TYPE=EXCLUSIVE:NIGHTLY")
1168 1169 1170 1171
                    continue
                fi
                read testcase <<< $(echo "$line"|grep -oEi "\w+$")

1172 1173 1174 1175
                if [[ "$is_nightly" != "" ]] && [ ${NIGHTLY_MODE:-OFF} == "OFF" ]; then
                    echo $testcase" will only run at night."
                    continue
                fi
C
chalsliu 已提交
1176 1177 1178 1179 1180 1181 1182 1183 1184 1185 1186 1187 1188
                if [ ${PRECISION_TEST:-OFF} == "ON" ] && [[ "$precision_cases" != "" ]]; then
                    will_test="false"
                    for case in $precision_cases; do
                        if [[ $testcase == $case ]]; then
                            will_test="true"
                            break
                        fi
                    done
                    if [[ $will_test == "false" ]]; then
                        echo $testcase" won't run in PRECISION_TEST mode."
                        continue
                    fi
                fi
1189

1190
                if [[ "$is_multicard" == "" ]]; then
1191
                  # trick: treat all test case with prefix "test_dist" as dist case, and would run on 2 GPUs
1192
                  read is_multicard <<< $(echo "$testcase"|grep -oEi "test_dist_")
1193 1194 1195 1196 1197 1198 1199 1200 1201 1202 1203 1204 1205 1206 1207
                fi

                if [[ "$is_exclusive" != "" ]]; then
                    if [[ "$exclusive_tests" == "" ]]; then
                        exclusive_tests="^$testcase$"
                    else
                        exclusive_tests="$exclusive_tests|^$testcase$"
                    fi
                elif [[ "$is_multicard" != "" ]]; then
                    if [[ "$multiple_card_tests" == "" ]]; then
                        multiple_card_tests="^$testcase$"
                    else
                        multiple_card_tests="$multiple_card_tests|^$testcase$"
                    fi
                else
1208 1209 1210 1211 1212 1213
                    if [[ $(echo $eight_parallel_job | grep $testcase) != "" ]]; then
                        single_card_tests_eight_parallel="$single_card_tests_eight_parallel|^$testcase$"
                    elif [[ $(echo $tetrad_parallel_jog | grep $testcase) != "" ]]; then
                        single_card_tests_tetrad_parallel="$single_card_tests_tetrad_parallel|^$testcase$"
                    elif [[ "${#single_card_tests_non_parallel_1}" -gt 10000 ]];then
                        single_card_tests_non_parallel_2="$single_card_tests_non_parallel_2|^$testcase$"
1214
                    else
1215
                        single_card_tests_non_parallel_1="$single_card_tests_non_parallel_1|^$testcase$"
1216
                    fi
1217
                    single_card_tests="$single_card_tests|^$testcase$"
1218 1219 1220
                fi
                is_exclusive=''
                is_multicard=''
1221
                is_nightly=''
1222 1223 1224 1225
                matchstr=''
                testcase=''
        done <<< "$test_cases";

1226 1227 1228 1229 1230 1231
        card_test "$single_card_tests_eight_parallel" 1 8     # run cases 8 job each time with single GPU
        card_test "$single_card_tests_tetrad_parallel" 1 4    # run cases 4 job each time with single GPU
        card_test "$single_card_tests_non_parallel_1" 1       # run cases 1 job each time with single GPU
        card_test "$single_card_tests_non_parallel_2" 1       # run cases 1 job each time with single GPU
        card_test "$multiple_card_tests" 2    # run cases with two GPUs
        card_test "$exclusive_tests"          # run cases exclusively, in this cases would be run with 4/8 GPUs
Z
zhangchunle 已提交
1232 1233
        collect_failed_tests
        rm -f $tmp_dir/*
1234 1235 1236 1237
        exec_times=0
        retry_unittests_record=''
        retry_time=3
        exec_time_array=('first' 'second' 'third')
1238 1239
        exec_retry_threshold=10
        is_retry_execuate=0
1240
        if [ -n "$failed_test_lists" ];then
1241 1242 1243
            read need_retry_ut_str <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(.+\)" | sed 's/(.\+)//' | sed 's/- //' )
            need_retry_ut_arr=(${need_retry_ut_str})
            need_retry_ut_count=${#need_retry_ut_arr[@]}
1244
            read retry_unittests <<< $(echo "$failed_test_lists" | grep -oEi "\-.+\(.+\)" | sed 's/(.\+)//' | sed 's/- //' )
1245
            if [ $need_retry_ut_count -lt $exec_retry_threshold ];then
1246
                while ( [ $exec_times -lt $retry_time ] )
1247 1248 1249 1250 1251 1252 1253 1254 1255 1256 1257 1258
                    do
                        retry_unittests_record="$retry_unittests_record$failed_test_lists"
                        failed_test_lists_ult=`echo "${failed_test_lists}" |grep -Po '[^ ].*$'`
                        echo "========================================="
                        echo "This is the ${exec_time_array[$exec_times]} time to re-run"
                        echo "========================================="
                        echo "The following unittest will be re-run:"
                        echo "${failed_test_lists_ult}"
                            
                        for line in ${retry_unittests[@]} ;
                            do

1259
                                read tmp_one_tmp <<< "$( echo $single_card_tests | grep -oEi $line )"
1260 1261 1262 1263 1264 1265 1266 1267 1268 1269 1270 1271 1272 1273 1274
                                read tmp_mul_tmp <<< "$( echo $multiple_card_tests | grep -oEi $line )"
                                read exclusive_tmp <<< "$( echo $exclusive_tests | grep -oEi $line )"

                                if [[ "$tmp_one_tmp" != ""  ]]; then
                                    if [[ "$one_card_retry" == "" ]]; then
                                        one_card_retry="^$line$"
                                    else
                                        one_card_retry="$one_card_retry|^$line$"
                                    fi
                                elif [[ "$tmp_mul_tmp" != "" ]]; then
                                    if [[ "$multiple_card_retry" == "" ]]; then
                                        multiple_card_retry="^$line$"
                                    else
                                        multiple_card_retry="$multiple_card_retry|^$line$"
                                    fi
1275
                                else
1276 1277 1278 1279 1280
                                    if [[ "$exclusive_retry" == "" ]];then
                                        exclusive_retry="^$line$"
                                    else
                                        exclusive_retry="$exclusive_retry|^$line$"
                                    fi
1281 1282
                                fi

1283
                            done
1284

1285 1286 1287
                        if [[ "$one_card_retry" != "" ]]; then
                            card_test "$one_card_retry" 1
                        fi
1288

1289 1290 1291
                        if [[ "$multiple_card_retry" != "" ]]; then
                            card_test "$multiple_card_retry" 2
                        fi
1292

1293 1294 1295 1296 1297 1298 1299 1300 1301 1302 1303 1304 1305
                        if [[ "$exclusive_retry" != "" ]]; then
                            card_test "$exclusive_retry"
                        fi
                        
                        exec_times=$[$exec_times+1]
                        failed_test_lists=''
                        collect_failed_tests
                        rm -f $tmp_dir/*
                        one_card_retry=''
                        multiple_card_retry=''
                        exclusive_retry=''
                    done
            else 
1306 1307
                # There are more than 10 failed unit tests, so no unit test retry
                is_retry_execuate=1
1308
            fi
1309 1310
        fi

1311
        if [[ "$EXIT_CODE" != "0" ]]; then
1312
            show_ut_retry_result
1313 1314 1315 1316 1317
        fi
set -ex
    fi
}

1318 1319 1320 1321 1322 1323 1324 1325 1326 1327 1328 1329 1330 1331 1332 1333 1334 1335 1336 1337 1338 1339 1340 1341 1342 1343 1344 1345 1346 1347 1348
function show_ut_retry_result() {
    if [[ "$is_retry_execuate" != "0" ]];then
        failed_test_lists_ult=`echo "${failed_test_lists}" | grep -Po '[^ ].*$'`
        echo "========================================="
        echo "There are more than 10 failed unit tests, so no unit test retry!!!"
        echo "========================================="
        echo "The following tests FAILED: "
        echo "${failed_test_lists_ult}"
        exit 8;
    else
        read retry_unittests_ut_name <<< $(echo "$retry_unittests_record" | grep -oEi "\-.+\(" | sed 's/(//' | sed 's/- //' )
        retry_unittests_record_judge=$(echo ${retry_unittests_ut_name}| tr ' ' '\n' | sort | uniq -c | awk '{if ($1 >=3) {print $2}}')
        if [ -z "${retry_unittests_record_judge}" ];then
            echo "========================================"
            echo "There are failed tests, which have been successful after re-run:"
            echo "========================================"
            echo "The following tests have been re-ran:"
            echo "${retry_unittests_record}"
        else
            failed_ut_re=$(echo "${retry_unittests_record_judge}" | awk BEGIN{RS=EOF}'{gsub(/\n/,"|");print}')
            echo "========================================"
            echo "There are failed tests, which have been executed re-run,but success rate is less than 50%:"
            echo "Summary Failed Tests... "
            echo "========================================"
            echo "The following tests FAILED: "
            echo "${retry_unittests_record}" | grep -E "$failed_ut_re"
            exit 8;
        fi
    fi
}

T
tianshuo78520a 已提交
1349 1350 1351 1352 1353 1354 1355 1356 1357 1358 1359 1360 1361 1362 1363 1364 1365 1366 1367
function parallel_test_base_cpu() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit cpu tests ...
    ========================================
EOF
        ut_startTime_s=`date +%s`
        ctest --output-on-failure -j $1
        ut_endTime_s=`date +%s`
        echo "CPU testCase Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
        if [[ "$EXIT_CODE" != "0" ]]; then
            exit 8;
        fi
    fi
}

T
tianshuo78520a 已提交
1368 1369 1370 1371 1372 1373 1374 1375 1376 1377 1378 1379 1380
function parallel_test_base_xpu() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    if [ ${WITH_TESTING:-ON} == "ON" ] ; then
    cat <<EOF
    ========================================
    Running unit cpu tests ...
    ========================================
EOF

set +x
        ut_startTime_s=`date +%s`
        test_cases=$(ctest -N -V | grep "_xpu" )        # cases list which would be run exclusively
T
tianshuo78520a 已提交
1381
        get_quickly_disable_ut||disable_ut_quickly=''   # indicate whether the case was in quickly disable list
T
tianshuo78520a 已提交
1382 1383 1384 1385 1386 1387 1388 1389 1390 1391 1392 1393 1394 1395 1396 1397 1398 1399 1400 1401 1402 1403
        while read -r line; do
            if [[ "$line" == "" ]]; then
                continue
            fi
            read testcase <<< $(echo "$line"|grep -oEi "\w+$")
            if [[ "$single_card_tests" == "" ]]; then
                single_card_tests="^$testcase$"
            else
                single_card_tests="$single_card_tests|^$testcase$"
            fi
        done <<< "$test_cases";
        card_test "$single_card_tests" 1
        collect_failed_tests
set -x
        ut_endTime_s=`date +%s`
        echo "XPU testCase Time: $[ $ut_endTime_s - $ut_startTime_s ]s"
        if [[ "$EXIT_CODE" != "0" ]]; then
            exit 8;
        fi
    fi   
}

1404
function parallel_test() {
Z
zhangchunle 已提交
1405
    ut_total_startTime_s=`date +%s`
1406 1407
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
1408
    pip install ${PADDLE_ROOT}/build/python/dist/*whl
T
tianshuo78520a 已提交
1409 1410 1411
    if [ "$WITH_GPU" == "ON" ];then
        parallel_test_base_gpu
    else
T
tianshuo78520a 已提交
1412 1413 1414 1415 1416
        if [ "$WITH_XPU" == "ON" ];then
            parallel_test_base_xpu
        else
            parallel_test_base_cpu ${PROC_RUN:-1}
        fi
T
tianshuo78520a 已提交
1417
    fi
Z
zhangchunle 已提交
1418 1419
    ut_total_endTime_s=`date +%s`
    echo "TestCases Total Time: $[ $ut_total_endTime_s - $ut_total_startTime_s ]s"
1420
    echo "ipipe_log_param_TestCases_Total_Time: $[ $ut_total_endTime_s - $ut_total_startTime_s ]s"
1421 1422
}

1423 1424 1425 1426 1427 1428 1429
function enable_unused_var_check() {
    # NOTE(zhiqiu): Set FLAGS_enable_unused_var_check=1 here to enable unused_var_check,
    # which checks if an operator has unused input variable(s).
    # Currently, use it in coverage CI job.
    export FLAGS_enable_unused_var_check=1
}

1430 1431 1432 1433 1434 1435 1436 1437 1438 1439 1440 1441 1442 1443 1444 1445 1446 1447
function gen_doc_lib() {
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
    cat <<EOF
    ========================================
    Building documentation library ...
    In /paddle/build
    ========================================
EOF
    cmake .. \
        -DCMAKE_BUILD_TYPE=Release \
        -DWITH_GPU=OFF \
        -DWITH_MKL=OFF \

    local LIB_TYPE=$1
    case $LIB_TYPE in
      full)
        # Build full Paddle Python module. Will timeout without caching 'copy_paddle_pybind' first
1448
        make -j `nproc` framework_py_proto copy_paddle_pybind paddle_python
1449 1450 1451 1452 1453 1454 1455 1456 1457 1458 1459 1460 1461
        ;;
      pybind)
        # Build paddle pybind library. Takes 49 minutes to build. Might timeout
        make -j `nproc` copy_paddle_pybind
        ;;
      proto)
        # Even smaller library.
        make -j `nproc` framework_py_proto
        ;;
      *)
        exit 0
        ;;
      esac
1462 1463 1464 1465 1466
}


function gen_dockerfile() {
    # Set BASE_IMAGE according to env variables
1467 1468
    CUDA_MAJOR="$(echo $CUDA_VERSION | cut -d '.' -f 1).$(echo $CUDA_VERSION | cut -d '.' -f 2)"
    CUDNN_MAJOR=$(echo $CUDNN_VERSION | cut -d '.' -f 1)
1469
    if [[ ${WITH_GPU} == "ON" ]]; then
1470
        BASE_IMAGE="nvidia/cuda:${CUDA_MAJOR}-cudnn${CUDNN_MAJOR}-devel-ubuntu16.04"
1471
    else
1472
        BASE_IMAGE="ubuntu:16.04"
1473 1474 1475 1476
    fi

    DOCKERFILE_GPU_ENV=""
    DOCKERFILE_CUDNN_DSO=""
X
Xi Chen 已提交
1477
    DOCKERFILE_CUBLAS_DSO=""
1478 1479
    if [[ ${WITH_GPU:-OFF} == 'ON' ]]; then
        DOCKERFILE_GPU_ENV="ENV LD_LIBRARY_PATH /usr/lib/x86_64-linux-gnu:\${LD_LIBRARY_PATH}"
X
Xi Chen 已提交
1480
        DOCKERFILE_CUDNN_DSO="RUN ln -sf /usr/lib/x86_64-linux-gnu/libcudnn.so.${CUDNN_MAJOR} /usr/lib/x86_64-linux-gnu/libcudnn.so"
X
Xi Chen 已提交
1481
        DOCKERFILE_CUBLAS_DSO="RUN ln -sf /usr/local/cuda/targets/x86_64-linux/lib/libcublas.so.${CUDA_MAJOR} /usr/lib/x86_64-linux-gnu/libcublas.so"
1482 1483 1484 1485
    fi

    cat <<EOF
    ========================================
1486
    Generate ${PADDLE_ROOT}/build/Dockerfile ...
1487 1488
    ========================================
EOF
1489 1490 1491 1492 1493 1494 1495 1496 1497 1498 1499 1500 1501 1502 1503
    
    ref_CUDA_MAJOR="$(echo $CUDA_VERSION | cut -d '.' -f 1)"
    if [[ ${WITH_GPU} == "ON"  ]]; then
        ref_gpu=gpu-cuda${ref_CUDA_MAJOR}-cudnn${CUDNN_MAJOR}
    else
        ref_gpu=cpu
    fi
    if [[ ${WITH_GPU} == "ON"  ]]; then
        install_gpu="_gpu"
    else
        install_gpu=""
    fi
    if [[ ${WITH_MKL} == "ON" ]]; then
        ref_mkl=mkl
    else
1504
        ref_mkl=openblas
1505
    fi
1506

1507 1508 1509 1510 1511 1512
    ref_web=https://paddle-wheel.bj.bcebos.com/${PADDLE_BRANCH}-${ref_gpu}-${ref_mkl}

    ref_paddle2=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp27-cp27mu-linux_x86_64.whl
    ref_paddle35=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp35-cp35m-linux_x86_64.whl
    ref_paddle36=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp36-cp36m-linux_x86_64.whl
    ref_paddle37=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1513
    ref_paddle38=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp38-cp38-linux_x86_64.whl
1514 1515 1516 1517 1518

    ref_paddle2_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp27-cp27mu-linux_x86_64.whl
    ref_paddle35_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp35-cp35m-linux_x86_64.whl
    ref_paddle36_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp36-cp36m-linux_x86_64.whl
    ref_paddle37_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1519
    ref_paddle38_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}-cp38-cp38-linux_x86_64.whl
1520

1521
    if [[ ${PADDLE_BRANCH} != "0.0.0" && ${WITH_MKL} == "ON" && ${WITH_GPU} == "ON" ]]; then
1522 1523 1524 1525
        ref_paddle2=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp35-cp35m-linux_x86_64.whl
        ref_paddle36=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp36-cp36m-linux_x86_64.whl
        ref_paddle37=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1526
        ref_paddle38=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp38-cp38-linux_x86_64.whl
1527 1528 1529 1530
        ref_paddle2_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp35-cp35m-linux_x86_64.whl
        ref_paddle36_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp36-cp36m-linux_x86_64.whl
        ref_paddle37_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp37-cp37m-linux_x86_64.whl
G
guofei 已提交
1531
        ref_paddle38_whl=paddlepaddle${install_gpu}-${PADDLE_BRANCH}.post${ref_CUDA_MAJOR}${CUDNN_MAJOR}-cp38-cp38-linux_x86_64.whl
1532 1533 1534 1535 1536 1537 1538 1539 1540 1541
    fi

    #ref_paddle2_mv1=""
    #ref_paddle2_mv2=""
    ref_paddle35_mv1=""
    ref_paddle35_mv2=""
    ref_paddle36_mv1=""
    ref_paddle36_mv2=""
    #ref_paddle37_mv1=""
    #ref_paddle37_mv2=""
1542
    if [[ ${PADDLE_BRANCH} == "0.0.0" && ${WITH_GPU} == "ON" ]]; then
1543 1544 1545 1546 1547 1548 1549 1550 1551 1552 1553 1554 1555
        #ref_paddle2_whl=paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35_whl=paddlepaddle_gpu-1.5.1-cp35-cp35m-linux_x86_64.whl
        ref_paddle36_whl=paddlepaddle_gpu-1.5.1-cp36-cp36m-linux_x86_64.whl
        #ref_paddle37_whl=paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl
        #ref_paddle2_mv1="mv ref_paddle2 paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl &&"
        #ref_paddle2_mv2="&& mv paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl ref_paddle2"
        ref_paddle35_mv1="mv ${ref_paddle35} ${ref_paddle35_whl} &&"
        ref_paddle35_mv2="&& mv ${ref_paddle35_whl} ${ref_paddle35}"
        ref_paddle36_mv1="mv ${ref_paddle36} ${ref_paddle36_whl} &&"
        ref_paddle36_mv2="&& mv ${ref_paddle36_whl} ${ref_paddle36}"
        #ref_paddle37_mv1="mv ref_paddle37 paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl &&"
        #ref_paddle37_mv2="&& mv paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl ref_paddle37"
    fi
1556
    if [[ ${PADDLE_BRANCH} == "0.0.0" && ${WITH_GPU} != "ON" ]]; then
1557 1558 1559 1560 1561 1562 1563 1564 1565 1566 1567 1568 1569 1570
        #ref_paddle2_whl=paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl
        ref_paddle35_whl=paddlepaddle-1.5.1-cp35-cp35m-linux_x86_64.whl
        ref_paddle36_whl=paddlepaddle-1.5.1-cp36-cp36m-linux_x86_64.whl
        #ref_paddle37_whl=paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl
        #ref_paddle2_mv1="mv ref_paddle2 paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl &&"
        #ref_paddle2_mv2="&& mv paddlepaddle_gpu-1.5.1-cp27-cp27mu-linux_x86_64.whl ref_paddle2"
        ref_paddle35_mv1="mv ${ref_paddle35} ${ref_paddle35_whl} &&"
        ref_paddle35_mv2="&& mv ${ref_paddle35_whl} ${ref_paddle35}"
        ref_paddle36_mv1="mv ${ref_paddle36} ${ref_paddle36_whl} &&"
        ref_paddle36_mv2="&& mv ${ref_paddle36_whl} ${ref_paddle36}"
        #ref_paddle37_mv1="mv ref_paddle37 paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl &&"
        #ref_paddle37_mv2="&& mv paddlepaddle_gpu-1.5.1-cp37-cp37m-linux_x86_64.whl ref_paddle37"
    fi
    
1571 1572 1573 1574 1575 1576 1577
    cat > ${PADDLE_ROOT}/build/Dockerfile <<EOF
    FROM ${BASE_IMAGE}
    MAINTAINER PaddlePaddle Authors <paddle-dev@baidu.com>
    ENV HOME /root
EOF

    if [[ ${WITH_GPU} == "ON"  ]]; then
1578
        NCCL_DEPS="apt-get install -y --allow-downgrades --allow-change-held-packages libnccl2=2.4.7-1+cuda${CUDA_MAJOR} libnccl-dev=2.4.7-1+cuda${CUDA_MAJOR} || true"
1579
    else
1580
        NCCL_DEPS="true"
1581 1582
    fi

1583 1584 1585 1586
    if [[ ${WITH_GPU} == "ON" && ${CUDA_MAJOR} = "8.0" ]]; then 
        NCCL_DEPS="apt-get install -y --allow-downgrades --allow-change-held-packages libnccl2=2.2.13-1+cuda8.0 libnccl-dev=2.2.13-1+cuda8.0"
    fi

T
Tao Luo 已提交
1587 1588
    PADDLE_VERSION="paddle version"
    CMD='"paddle", "version"'
1589 1590
    
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1591 1592 1593
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y wget python3 python3-pip libgtk2.0-dev dmidecode python3-tk && \
T
tianshuo78520a 已提交
1594
        pip3 install py-cpuinfo==5.0.0 && wget ${ref_web}/${ref_paddle35} && ${ref_paddle35_mv1} pip3 install ${ref_paddle35_whl} ${ref_paddle35_mv2}; apt-get install -f -y && \
1595
        apt-get clean -y && \
1596
        rm -f ${ref_paddle35} && \
1597 1598 1599 1600
        ldconfig
    ${DOCKERFILE_CUDNN_DSO}
    ${DOCKERFILE_CUBLAS_DSO}
    ${DOCKERFILE_GPU_ENV}
1601
EOF
1602
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1603 1604 1605 1606 1607 1608 1609
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN mkdir -p /root/python_build/ && wget -q https://www.sqlite.org/2018/sqlite-autoconf-3250300.tar.gz && \
        tar -zxf sqlite-autoconf-3250300.tar.gz && cd sqlite-autoconf-3250300 && \
T
Tao Luo 已提交
1610
        ./configure -prefix=/usr/local && make install -j8 && cd ../ && rm sqlite-autoconf-3250300.tar.gz && \
1611 1612 1613
        wget -q https://www.python.org/ftp/python/3.6.0/Python-3.6.0.tgz && \
        tar -xzf Python-3.6.0.tgz && cd Python-3.6.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
1614 1615
        make -j8 > /dev/null && make altinstall > /dev/null && cd ../ && rm Python-3.6.0.tgz
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && ldconfig && \
T
tianshuo78520a 已提交
1616
        wget ${ref_web}/${ref_paddle36} && ${ref_paddle36_mv1} pip3.6 install ${ref_paddle36_whl} ${ref_paddle36_mv2}; apt-get install -f -y && \
1617
        apt-get clean -y && \
1618
        rm -f ${ref_paddle36} && \
1619 1620
        ldconfig
EOF
1621
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1622 1623 1624 1625 1626 1627 1628 1629
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN wget -q https://www.python.org/ftp/python/3.7.0/Python-3.7.0.tgz && \
        tar -xzf Python-3.7.0.tgz && cd Python-3.7.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
1630 1631
        make -j8 > /dev/null && make altinstall > /dev/null && cd ../ && rm Python-3.7.0.tgz
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && ldconfig && \
T
tianshuo78520a 已提交
1632
        wget ${ref_web}/${ref_paddle37} && pip3.7 install ${ref_paddle37_whl}; apt-get install -f -y && \
1633
        apt-get clean -y && \
1634
        rm -f ${ref_paddle37} && \
1635
        ldconfig
G
guofei 已提交
1636 1637 1638 1639 1640 1641 1642 1643 1644 1645 1646 1647
EOF
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
    # run paddle version to install python packages first
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y make build-essential libssl-dev zlib1g-dev libbz2-dev \
        libreadline-dev libsqlite3-dev wget curl llvm libncurses5-dev libncursesw5-dev \
        xz-utils tk-dev libffi-dev liblzma-dev
    RUN wget -q https://www.python.org/ftp/python/3.8.0/Python-3.8.0.tgz && \
        tar -xzf Python-3.8.0.tgz && cd Python-3.8.0 && \
        CFLAGS="-Wformat" ./configure --prefix=/usr/local/ --enable-shared > /dev/null && \
        make -j8 > /dev/null && make altinstall > /dev/null && cd ../ && rm Python-3.8.0.tgz
    RUN apt-get install -y libgtk2.0-dev dmidecode python3-tk && ldconfig && \
T
tianshuo78520a 已提交
1648
        wget ${ref_web}/${ref_paddle38} && pip3.8 install ${ref_paddle38_whl}; apt-get install -f -y && \
G
guofei 已提交
1649 1650 1651
        apt-get clean -y && \
        rm -f ${ref_paddle38} && \
        ldconfig
1652
EOF
1653
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1654
    # run paddle version to install python packages first
1655 1656
    RUN apt-get update && ${NCCL_DEPS}
    RUN apt-get install -y wget python-pip python-opencv libgtk2.0-dev dmidecode python-tk && easy_install -U pip && \
1657
        wget ${ref_web}/${ref_paddle2} && pip install ${ref_paddle2_whl}; apt-get install -f -y && \
1658
        apt-get clean -y && \
1659
        rm -f ${ref_paddle2} && \
1660 1661
        ${PADDLE_VERSION} && \
        ldconfig
1662
EOF
1663

1664
    cat >> ${PADDLE_ROOT}/build/Dockerfile <<EOF
1665 1666 1667 1668 1669
    # default command shows the paddle version and exit
    CMD [${CMD}]
EOF
}

1670
function gen_fluid_lib() {
L
Lei Wang 已提交
1671 1672
    mkdir -p ${PADDLE_ROOT}/build
    cd ${PADDLE_ROOT}/build
T
Tao Luo 已提交
1673
    cat <<EOF
1674
    ========================================
1675
    Generating fluid library for train and inference ...
1676 1677
    ========================================
EOF
1678 1679 1680 1681
    parallel_number=`nproc`
    if [[ "$1" != "" ]]; then
      parallel_number=$1
    fi
Z
zhangchunle 已提交
1682 1683 1684
    startTime_s=`date +%s`
    set +e
    cmake .. -DWITH_DISTRIBUTE=OFF -DON_INFER=ON -DCUDA_ARCH_NAME=${CUDA_ARCH_NAME:-Auto};build_error=$?
L
LoveAn 已提交
1685 1686 1687 1688

    # reset ccache zero stats for collect PR's actual hit rate
    ccache -z

Z
zhangchunle 已提交
1689 1690
    make -j ${parallel_number} fluid_lib_dist;build_error=$?
    make -j ${parallel_number} inference_lib_dist;build_error=$?
L
LoveAn 已提交
1691 1692 1693 1694

    # ci will collect ccache hit rate
    collect_ccache_hits

Z
zhangchunle 已提交
1695 1696 1697
    if [ "$build_error" != 0 ];then
        exit 7;
    fi
Z
zhangchunle 已提交
1698 1699
    endTime_s=`date +%s`
    echo "Build Time: $[ $endTime_s - $startTime_s ]s"
1700
    echo "ipipe_log_param_Build_Time: $[ $endTime_s - $startTime_s ]s"
L
LoveAn 已提交
1701

1702
    build_size "paddle_inference"
T
Tao Luo 已提交
1703 1704
}

1705
function tar_fluid_lib() {
T
Tao Luo 已提交
1706
    cat <<EOF
T
Tao Luo 已提交
1707
    ========================================
1708
    Taring fluid library for train and inference ...
T
Tao Luo 已提交
1709 1710
    ========================================
EOF
T
Tao Luo 已提交
1711
    cd ${PADDLE_ROOT}/build
1712
    cp -r paddle_install_dir fluid
T
Tao Luo 已提交
1713
    tar -czf fluid.tgz fluid
1714 1715
    cp -r paddle_inference_install_dir paddle_inference
    tar -czf paddle_inference.tgz paddle_inference
1716 1717
}

1718
function test_fluid_lib() {
T
Tao Luo 已提交
1719
    cat <<EOF
1720
    ========================================
1721
    Testing fluid library for inference ...
1722 1723
    ========================================
EOF
Z
zhangchunle 已提交
1724
    fluid_startTime_s=`date +%s`
T
Tao Luo 已提交
1725 1726 1727 1728
    cd ${PADDLE_ROOT}/paddle/fluid/inference/api/demo_ci
    ./run.sh ${PADDLE_ROOT} ${WITH_MKL:-ON} ${WITH_GPU:-OFF} ${INFERENCE_DEMO_INSTALL_DIR} \
             ${TENSORRT_INCLUDE_DIR:-/usr/local/TensorRT/include} \
             ${TENSORRT_LIB_DIR:-/usr/local/TensorRT/lib}
T
tianshuo78520a 已提交
1729
    EXIT_CODE=$?
Z
zhangchunle 已提交
1730
    fluid_endTime_s=`date +%s`
1731 1732
    echo "test_fluid_lib Total Time: $[ $fluid_endTime_s - $fluid_startTime_s ]s"
    echo "ipipe_log_param_Test_Fluid_Lib_Total_Time: $[ $fluid_endTime_s - $fluid_startTime_s ]s"          
T
Tao Luo 已提交
1733
    ./clean.sh
T
tianshuo78520a 已提交
1734 1735 1736
    if [[ "$EXIT_CODE" != "0" ]]; then
        exit 8;
    fi
1737 1738
}

1739 1740 1741 1742 1743 1744
function test_fluid_lib_train() {
    cat <<EOF
    ========================================
    Testing fluid library for training ...
    ========================================
EOF
Z
zhangchunle 已提交
1745
    fluid_train_startTime_s=`date +%s`
1746 1747
    cd ${PADDLE_ROOT}/paddle/fluid/train/demo
    ./run.sh ${PADDLE_ROOT} ${WITH_MKL:-ON}
T
tianshuo78520a 已提交
1748
    EXIT_CODE=$?
Z
zhangchunle 已提交
1749 1750
    fluid_train_endTime_s=`date +%s`
    echo "test_fluid_lib_train Total Time: $[ $fluid_train_endTime_s - $fluid_train_startTime_s ]s"
1751
    echo "ipipe_log_param_Test_Fluid_Lib_Train_Total_Time: $[ $fluid_train_endTime_s - $fluid_train_startTime_s ]s"
1752
    ./clean.sh
T
tianshuo78520a 已提交
1753 1754 1755
    if [[ "$EXIT_CODE" != "0" ]]; then
        exit 8;
    fi
1756
}
T
tianshuo78520a 已提交
1757

T
tianshuo78520a 已提交
1758

T
tianshuo78520a 已提交
1759 1760 1761 1762 1763
function build_document_preview() {
    sh /paddle/tools/document_preview.sh ${PORT}
}


T
tianshuo78520a 已提交
1764
function example() {
Z
Zeng Jinle 已提交
1765
    pip install ${PADDLE_ROOT}/build/python/dist/*.whl
T
tianshuo78520a 已提交
1766
    paddle version
1767
    cd ${PADDLE_ROOT}/tools
Z
zhangchunle 已提交
1768 1769
    python sampcd_processor.py cpu;example_error=$?
    if [ "$example_error" != "0" ];then
1770
      echo "Code instance execution failed" >&2
Z
zhangchunle 已提交
1771
      exit 5
T
tianshuo78520a 已提交
1772 1773 1774
    fi
}

L
LoveAn 已提交
1775 1776 1777 1778

function collect_ccache_hits() {
    rate=$(ccache -s | grep 'cache hit rate' | awk '{print $4}')
    echo "ccache hit rate: ${rate}%"
1779
    echo "ipipe_log_param_Ccache_Hit_Rate: ${rate}%"
L
LoveAn 已提交
1780 1781 1782
}


1783
function test_op_benchmark() {
1784 1785 1786 1787 1788 1789 1790 1791 1792 1793 1794 1795 1796 1797 1798
    # The PR will pass quickly when get approval from specific person.
    # Xreki 12538138, luotao1 6836917, GaoWei8 53294385
    set +x
    approval_line=$(curl -H "Authorization: token ${GITHUB_API_TOKEN}" https://api.github.com/repos/PaddlePaddle/Paddle/pulls/${GIT_PR_ID}/reviews?per_page=10000)
    if [ "${approval_line}" != "" ]; then
        APPROVALS=$(echo ${approval_line} | python ${PADDLE_ROOT}/tools/check_pr_approval.py 1 53294385 12538138 6836917)
        echo "current pr ${GIT_PR_ID} got approvals: ${APPROVALS}"
        if [ "${APPROVALS}" == "TRUE" ]; then
            echo "==================================="
            echo -e "\n current pr ${GIT_PR_ID} has got approvals. So, Pass CI directly!\n"
            echo "==================================="
            exit 0
        fi
    fi
    set -x
1799 1800 1801
    bash ${PADDLE_ROOT}/tools/test_op_benchmark.sh
}

1802 1803 1804 1805
function summary_check_problems() {
    set +x
    local check_style_code=$1
    local example_code=$2
1806 1807
    local check_style_info=$3
    local example_info=$4
1808 1809 1810
    if [ $check_style_code -ne 0 -o $example_code -ne 0 ];then
      echo "========================================"
      echo "summary problems:"
1811 1812 1813 1814 1815 1816
      if [ $check_style_code -ne 0 -a $example_code -ne 0 ];then
        echo "There are 2 errors: Code format error and Example code error."
      else
        [ $check_style_code -ne 0 ] && echo "There is 1 error: Code format error."
        [ $example_code -ne 0 ] && echo "There is 1 error: Example code error."
      fi
1817 1818
      echo "========================================"
      if [ $check_style_code -ne 0 ];then
1819 1820
        echo "*****Code format error***** Please fix it according to the diff information:"
        echo "$check_style_info" | grep "code format error" -A $(echo "$check_style_info" | wc -l)
1821 1822
      fi
      if [ $example_code -ne 0 ];then
1823 1824
        echo "*****Example code error***** Please fix the error listed in the information:"
        echo "$example_info" | grep "API check -- Example Code" -A $(echo "$example_info" | wc -l)
1825 1826 1827 1828 1829 1830 1831
      fi
      [ $check_style_code -ne 0 ] && exit $check_style_code
      [ $example_code -ne 0 ] && exit $example_code
    fi
    set -x
}

1832
function main() {
Z
Zeng Jinle 已提交
1833
    local CMD=$1 
1834
    local parallel_number=$2
1835
    init
I
iducn 已提交
1836 1837
    if [ "$CMD" != "assert_file_approvals" ];then
      python ${PADDLE_ROOT}/tools/summary_env.py
I
iducn 已提交
1838
      bash ${PADDLE_ROOT}/tools/get_cpu_info.sh
I
iducn 已提交
1839
    fi
1840
    case $CMD in
1841
      build_only)
Z
zhangchunle 已提交
1842
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1843 1844
        ;;
      build_and_check)
1845
        set +e
1846
        check_style_info=$(check_style)
1847
        check_style_code=$?
Z
Zeng Jinle 已提交
1848
        generate_upstream_develop_api_spec ${PYTHON_ABI:-""} ${parallel_number}
Z
zhangchunle 已提交
1849
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1850 1851
        check_sequence_op_unittest
        generate_api_spec ${PYTHON_ABI:-""} "PR"
1852 1853
        set +e
        example_info=$(example)
1854
        example_code=$?
1855
        summary_check_problems $check_style_code $example_code "$check_style_info" "$example_info"
T
tianshuo78520a 已提交
1856
        assert_api_spec_approvals
1857
        ;;
1858 1859
      build)
        cmake_gen ${PYTHON_ABI:-""}
1860
        build ${parallel_number}
1861
        gen_dockerfile ${PYTHON_ABI:-""}
1862
        assert_api_spec_approvals
1863
        ;;
1864 1865
      combine_avx_noavx)
        combine_avx_noavx_build
1866
        gen_dockerfile ${PYTHON_ABI:-""}
1867 1868 1869
        ;;
      combine_avx_noavx_build_and_test)
        combine_avx_noavx_build
1870
        gen_dockerfile ${PYTHON_ABI:-""}
1871 1872
        parallel_test_base
        ;;
1873
      test)
1874
        parallel_test
1875
        ;;
1876 1877 1878
      single_test)
        single_test $2
        ;;
1879 1880 1881
      bind_test)
        bind_test
        ;;
1882 1883 1884
      gen_doc_lib)
        gen_doc_lib $2
        ;;
1885
      dockerfile)
1886
        gen_dockerfile ${PYTHON_ABI:-""}
1887 1888 1889
        ;;
      fluid_inference_lib)
        cmake_gen ${PYTHON_ABI:-""}
1890
        gen_fluid_lib ${parallel_number}
1891 1892
        tar_fluid_lib
        test_fluid_lib
1893
        ;;
1894 1895 1896 1897
      build_inference_lib)
        cmake_gen ${PYTHON_ABI:-""}
        gen_fluid_lib ${parallel_number}
        ;;
1898 1899 1900
      check_style)
        check_style
        ;;
L
Lei Wang 已提交
1901
      cicheck)
1902 1903 1904 1905 1906 1907
        cmake_gen ${PYTHON_ABI:-""}
        build ${parallel_number}
        enable_unused_var_check
        parallel_test
        ;;
      cicheck_coverage)
1908
        check_approvals_of_unittest 1
1909
        check_diff_file_for_coverage
Z
zhangchunle 已提交
1910
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1911
        enable_unused_var_check
1912
        parallel_test
L
Liu Xudong 已提交
1913
        check_coverage
1914
        check_change_of_unittest ${PYTHON_ABI:-""}
L
Lei Wang 已提交
1915
        ;;
G
gongweibao 已提交
1916 1917
      cicheck_brpc)
        cmake_gen ${PYTHON_ABI:-""}
1918
        build ${parallel_number}
G
gongweibao 已提交
1919 1920
        run_brpc_test
        ;;
1921
      assert_api)
Z
Zeng Jinle 已提交
1922
        generate_upstream_develop_api_spec ${PYTHON_ABI:-""} ${parallel_number}
Y
Yu Yang 已提交
1923
        assert_api_spec_approvals
1924 1925
        ;;
      test_inference)
1926 1927
        PADDLE_ROOT="$( cd "$( dirname "${BASH_SOURCE[0]}")/../../" && pwd )"
        python ${PADDLE_ROOT}/tools/remove_grad_op_and_kernel.py
1928
        gen_fluid_lib ${parallel_number}
1929
        test_fluid_lib
T
tianshuo78520a 已提交
1930
        #test_fluid_lib_train
1931 1932 1933 1934
        ;;
      test_train)
        gen_fluid_lib ${parallel_number}
        test_fluid_lib_train
1935 1936 1937 1938
        ;;
      assert_api_approvals)
        assert_api_spec_approvals
        ;;
Z
zhangchunle 已提交
1939 1940 1941
      assert_file_approvals)
        assert_file_diff_approvals
        ;; 
1942
      maccheck)
Z
zhangchunle 已提交
1943
        cmake_gen_and_build_mac ${PYTHON_ABI:-""}
L
lujun 已提交
1944
        run_mac_test ${PYTHON_ABI:-""} ${PROC_RUN:-1}
1945
        ;;
1946
      maccheck_py35)
Z
zhangchunle 已提交
1947
        cmake_gen_and_build_mac ${PYTHON_ABI:-""}
1948
        run_mac_test ${PYTHON_ABI:-""} ${PROC_RUN:-1}
1949
        check_change_of_unittest ${PYTHON_ABI:-""}
1950
        ;;
J
JiabinYang 已提交
1951 1952 1953 1954
      macbuild)
        cmake_gen ${PYTHON_ABI:-""}
        build_mac
        ;;
M
minqiyang 已提交
1955
      cicheck_py35)
Z
zhangchunle 已提交
1956
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
1957
        parallel_test
M
minqiyang 已提交
1958
        ;;
T
tianshuo78520a 已提交
1959 1960 1961 1962
      check_xpu)
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
        parallel_test
        ;;
Y
YUNSHEN XIE 已提交
1963 1964 1965 1966 1967
      check_xpu_coverage)
        cmake_gen_and_build ${PYTHON_ABI:-""} ${parallel_number}
        parallel_test
        check_coverage
        ;;
Y
Yu Yang 已提交
1968 1969 1970
      cmake_gen)
        cmake_gen ${PYTHON_ABI:-""}
        ;;
C
chalsliu 已提交
1971 1972 1973
      cmake_gen_in_current_dir)
        cmake_gen_in_current_dir ${PYTHON_ABI:-""}
        ;;
Y
Yu Yang 已提交
1974
      gen_fluid_lib)
1975
        gen_fluid_lib ${parallel_number}
Y
Yu Yang 已提交
1976 1977 1978 1979
        ;;
      test_fluid_lib)
        test_fluid_lib
        ;;
T
tianshuo78520a 已提交
1980 1981 1982 1983 1984
      document)
        cmake_gen ${PYTHON_ABI:-""}
        build ${parallel_number}
        build_document_preview
        ;;
T
tianshuo78520a 已提交
1985 1986 1987
      api_example)
        example
        ;;
1988 1989 1990
      test_op_benchmark)
        test_op_benchmark
        ;;
1991 1992
      *)
        print_usage
1993
        exit 1
1994 1995
        ;;
      esac
1996
      echo "paddle_build script finished as expected"
1997 1998 1999
}

main $@